/*
 * File         : BV_Svc_Handler.cpp
 * Author       : Tomasz Stachowiak
 * Created      : Wed May 20 20:16:35 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#include "BV_Message.h"

#include <BVN/Event_Handler.h>
#include <BVN/Svc_Handler.h>
#include <BVN/SOCK_Stream.h>

#include "BV_Session_Control.h"
#include "BV.h"
#include "BV_Svc_Handler.h"

int BV_Svc_Handler::handle_event(Event_Type et)
{
  BVN_DEBUG("BV_Svc_Handler::handle_event\n");

  BV_Message msg(this->peer());
  if(msg.recv(this->peer()) <= 0)
    {
      BV_Session_Control *ctrl = BV_Session_Control::instance();
      ctrl->connection_closed(this->peer());
      ctrl->destroy();
      reactor_->remove_handler(this, READ_EVENT);
      this->peer()->close();
      return -1;
    }
  else
    msg.execute();

  return 0;
}
